Imports Microsoft.Win32
Imports System.Collections

Public Class RegistryUtility

    Private Sub New()
    End Sub

    Private Shared Function GetKeyTypeAndPath(ByVal fullpath As String, ByRef keytype As String, ByRef keypath As String) As Boolean
        Dim indexComputer As Integer = fullpath.IndexOf("\")
        If indexComputer = -1 Then
            Return False
        End If
        Dim indexKey As Integer = fullpath.IndexOf("\", indexComputer + 1)
        If indexKey = -1 Then
            keytype = fullpath.Substring(indexComputer + 1)
            keypath = ""
        Else
            keytype = fullpath.Substring(indexComputer + 1, indexKey - indexComputer - 1)
            keypath = fullpath.Substring(indexKey + 1)
        End If
        Return True
    End Function

    Private Shared Function GetRegistryKey(ByVal keytype As String, ByVal keypath As String) As RegistryKey
        Dim rKey As RegistryKey
        Select Case keytype
            Case "HKEY_CLASSES_ROOT"
                rKey = Registry.ClassesRoot.OpenSubKey(keypath)
            Case "HKEY_CURRENT_USER"
                rKey = Registry.CurrentUser.OpenSubKey(keypath)
            Case "HKEY_LOCAL_MACHINE"
                rKey = Registry.LocalMachine.OpenSubKey(keypath)
            Case "HKEY_USERS"
                rKey = Registry.Users.OpenSubKey(keypath)
            Case "HKEY_CURRENT_CONFIG"
                rKey = Registry.CurrentConfig.OpenSubKey(keypath)
            Case Else
                Return Nothing
        End Select
        Return rKey
    End Function

    Public Shared Function GetSubKeys(ByVal fullpath As String) As String()
        Dim keytype As String = ""
        Dim keypath As String = ""

        Dim arrayString As New ArrayList()

        Try
            Dim bValidKey As Boolean = GetKeyTypeAndPath(fullpath, keytype, keypath)
            If bValidKey = False Then
                Throw (New Exception())
            End If

            Dim rKey As RegistryKey = GetRegistryKey(keytype, keypath)
            If rKey Is Nothing Then
                Throw (New Exception())
            End If
            Dim keyName As String
            For Each keyName In rKey.GetSubKeyNames()
                arrayString.Add(keyName)
            Next keyName
            rKey.Close()
        Catch
        End Try

        Return CType(arrayString.ToArray(GetType(String)), String())
    End Function

    Public Shared Function GetValues(ByVal fullpath As String) As String()()
        Dim keytype As String = ""
        Dim keypath As String = ""

        Dim arrayStringArray As New ArrayList()

        Dim data As Object
        Try
            Dim bValidKey As Boolean = GetKeyTypeAndPath(fullpath, keytype, keypath)
            If bValidKey = False Then
                Throw (New Exception())
            End If

            Dim rKey As RegistryKey = RegistryUtility.GetRegistryKey(keytype, keypath)
            If rKey Is Nothing Then
                Throw (New Exception())
            End If

            Dim dafualtValue As String = CStr(rKey.GetValue(""))
            arrayStringArray.Add(New String() {"()", "REG_SZ", IIf(Not (dafualtValue Is Nothing), dafualtValue, "(l̐ݒȂ)")})

            Dim valueName As String
            For Each valueName In rKey.GetValueNames()
                If valueName <> "" Then
                    data = rKey.GetValue(valueName)

                    If TypeOf data Is String Then
                        arrayStringArray.Add(New String() {valueName, "REG_SZ", data.ToString()})
                    ElseIf TypeOf data Is Int32 Then
                        Dim temp As Int64 = CType(data, Int32)
                        If temp < 0 Then
                            temp = temp + &HFFFFFFFF
                            temp = temp + 1
                        End If
                        arrayStringArray.Add(New String() {valueName, "REG_DWORD", String.Format("0x{0:x8} ({1:d})", CType(data, Int32), temp)})
                    ElseIf TypeOf data Is [Byte]() Then
                        Dim bytedata As String = ""
                        If CType(data, [Byte]()).Length = 0 Then
                            bytedata = "( 0 ̃oCil)"
                        End If
                        Dim i As Integer
                        For i = 0 To (CType(data, [Byte]()).Length) - 1
                            If i > 70 Then
                                bytedata += "..."
                                Exit For
                            End If
                            bytedata += String.Format("{0:x2} ", CType(data, [Byte]())(i))
                        Next i
                        arrayStringArray.Add(New String() {valueName, "REG_BINARY", bytedata})
                    ElseIf TypeOf data Is String() Then
                        Dim sumLength As Integer = 0
                        Dim multidata As String = ""
                        Dim i As Integer
                        For i = 0 To (CType(data, String()).Length) - 1
                            If sumLength > 210 Then
                                multidata += "..."
                                Exit For
                            End If
                            multidata += String.Format("{0} ", CType(data, String())(i))
                            sumLength += CType(data, String())(i).Length
                        Next i
                        arrayStringArray.Add(New String() {valueName, "REG_MULTI_SZ", multidata})
                    Else
                        'REG_RESOURCE_LISTAREG_RESOURCE_LIST 
                        arrayStringArray.Add(New String() {valueName, ".NETΉ̃f[^^ł", "f[^QƁE삷邱͂ł܂"})
                    End If
                End If
            Next
            rKey.Close()
        Catch
        End Try

        Return CType(arrayStringArray.ToArray(GetType(String())), String()())
    End Function

End Class
